package tools;

import java.io.*;

public abstract class GenericTextReader {

  abstract public void close();
  abstract public boolean eofReached();
  abstract public String readLine();
  abstract public String readString();
  abstract public int readInt();
  abstract public double readDouble();
  abstract public boolean readBoolean();
  abstract public void skip();
  abstract public boolean hasMoreFields();
}
