package tools;

import java.io.*;

abstract class GenericTextWriter {

  public abstract void close();
  public abstract void flush();

  public abstract void print(int n);
  public abstract void print(double x);
  public abstract void print(String s);
  public abstract void println();

  public void print(boolean b) { print(b ? "true" : "false"); }
  public void println(int n) { print(n); println(); }
  public void println(double x) { print(x); println(); }
  public void println(String s) { print(s); println(); }
  public void println(boolean b) { print(b); println(); }
}
