package tools;

import java.io.*;

public class TextWriter {

  GenericTextWriter out;

  // Constructors
  public TextWriter(String fn) {
    out= new RawTextWriter(fn);
  }

  public TextWriter(String fn, String sep) {
    out= new FieldTextWriter(fn, sep);
  }

  // Methods

  public void close() { out.close(); }
  public void flush() { out.flush(); }

  public void print(int n) { out.print(n); }
  public void print(double x) { out.print(x); }
  public void print(String s) { out.print(s); }
  public void print(boolean b) { out.print(b); }
  public void println() { out.println(); }

  public void println(int n) { out.println(n); }
  public void println(double x) { out.println(x); }
  public void println(String s) { out.println(s); }
  public void println(boolean b) { out.println(b); }
}
